module Read where
import DataTypes
import Prec
import ArrowClasses(Arrow(arr,(>>>)),
                    (**>),
		    ArrowPlus((<|>)),
		    ArrowSymbol(readSymbol),
                    ArrowPrec(mayReadParen,setPrec),
                    ArrowReadShow)
pread_f0 :: ArrowReadShow a => a () b -> a () [b]
pread_f0 p = (\z ->
		asTypeOf
		  ((freadSum_f0 (constructorNamesAndArities_f0 z) p (pread_f0 p)) >>> (arr inn_f0))
		  (arr (const z)))
	       undefined
pread_f1A :: ArrowReadShow a => a () b -> a () (A b)
pread_f1A p = (\z ->
		 asTypeOf
		   ((freadSum_f1A (constructorNamesAndArities_f1A z) p (pread_f1A p)) >>>
		    (arr inn_f1A))
		   (arr (const z)))
		undefined
pread_f4Tree :: ArrowReadShow a => a () b -> a () (Tree b)
pread_f4Tree p = (\z ->
		    asTypeOf
		      ((freadSum_f4Tree
			  (constructorNamesAndArities_f4Tree z)
			  p
			  (pread_f4Tree p)) >>>
		       (arr inn_f4Tree))
		      (arr (const z)))
		   undefined
pread_f4Rose :: ArrowReadShow a => a () b -> a () (Rose b)
pread_f4Rose p = (\z ->
		    asTypeOf
		      ((freadSum_f4Rose
			  (constructorNamesAndArities_f4Rose z)
			  p
			  (pread_f4Rose p)) >>>
		       (arr inn_f4Rose))
		      (arr (const z)))
		   undefined
pread_f4List :: ArrowReadShow a => a () b -> a () (List b)
pread_f4List p = (\z ->
		    asTypeOf
		      ((freadSum_f4List
			  (constructorNamesAndArities_f4List z)
			  p
			  (pread_f4List p)) >>>
		       (arr inn_f4List))
		      (arr (const z)))
		   undefined
pread_f10TreeOfList :: ArrowReadShow a => a () b -> a () (TreeOfList b)
pread_f10TreeOfList p = (\z ->
			   asTypeOf
			     ((freadSum_f10TreeOfList
				 (constructorNamesAndArities_f10TreeOfList z)
				 p
				 (pread_f10TreeOfList p)) >>>
			      (arr inn_f10TreeOfList))
			     (arr (const z)))
			  undefined
pread_f8RoseTree :: ArrowReadShow a => a () b -> a () (RoseTree b)
pread_f8RoseTree p = (\z ->
			asTypeOf
			  ((freadSum_f8RoseTree
			      (constructorNamesAndArities_f8RoseTree z)
			      p
			      (pread_f8RoseTree p)) >>>
			   (arr inn_f8RoseTree))
			  (arr (const z)))
		       undefined
pread_f5Maybe :: ArrowReadShow a => a () b -> a () (Maybe b)
pread_f5Maybe p = (\z ->
		     asTypeOf
		       ((freadSum_f5Maybe
			   (constructorNamesAndArities_f5Maybe z)
			   p
			   (pread_f5Maybe p)) >>>
			(arr inn_f5Maybe))
		       (arr (const z)))
		    undefined
freadSum_f0 :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either () (b, c))
freadSum_f0 = \(s : ss) p r -> (freadSum_e (s : []) p r) <|> (freadSum_Ppr ss p r)
constructorNamesAndArities_f0 :: [a] -> [([Char], Int)]
constructorNamesAndArities_f0 = fconstructorNamesAndArities_f0 . out_f0
inn_f0 :: Either () (a, [a]) -> [a]
inn_f0 = either (const []) (uncurry (:))
freadSum_f1A ::
  ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either () (Either c (c, (b, c))))
freadSum_f1A = \(s : ss) p r -> (freadSum_e (s : []) p r) <|> (freadSum_SrPrPpr ss p r)
constructorNamesAndArities_f1A :: A a -> [([Char], Int)]
constructorNamesAndArities_f1A = fconstructorNamesAndArities_f1A . out_f1A
inn_f1A :: Either () (Either (A a) (A a, (a, A a))) -> A a
inn_f1A = either (const B) (either C (uncurry3 D))
freadSum_f4Tree :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either b (c, c))
freadSum_f4Tree = \(s : ss) p r -> (freadSum_p (s : []) p r) <|> (freadSum_Prr ss p r)
constructorNamesAndArities_f4Tree :: Tree a -> [([Char], Int)]
constructorNamesAndArities_f4Tree = fconstructorNamesAndArities_f4Tree . out_f4Tree
inn_f4Tree :: Either a (Tree a, Tree a) -> Tree a
inn_f4Tree = either Leaf (uncurry Bin)
freadSum_f4Rose :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (b, [c])
freadSum_f4Rose = \(s : ss) p r ->
		    mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_PpA0r p r))
constructorNamesAndArities_f4Rose :: Rose a -> [([Char], Int)]
constructorNamesAndArities_f4Rose = fconstructorNamesAndArities_f4Rose . out_f4Rose
inn_f4Rose :: (a, [Rose a]) -> Rose a
inn_f4Rose = uncurry Fork
freadSum_f4List :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either () (b, c))
freadSum_f4List = \(s : ss) p r -> (freadSum_e (s : []) p r) <|> (freadSum_Ppr ss p r)
constructorNamesAndArities_f4List :: List a -> [([Char], Int)]
constructorNamesAndArities_f4List = fconstructorNamesAndArities_f4List . out_f4List
inn_f4List :: Either () (a, List a) -> List a
inn_f4List = either (const Nil) (uncurry Cons)
freadSum_f10TreeOfList ::
  ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Tree (List b))
freadSum_f10TreeOfList = \(s : ss) p r ->
			   mayReadParen
			     (prec s)
			     ((readSymbol (fst s)) >>> (freadProd_A4TreeA4Listp p r))
constructorNamesAndArities_f10TreeOfList :: TreeOfList a -> [([Char], Int)]
constructorNamesAndArities_f10TreeOfList = fconstructorNamesAndArities_f10TreeOfList .
					   out_f10TreeOfList
inn_f10TreeOfList :: Tree (List a) -> TreeOfList a
inn_f10TreeOfList = TL
freadSum_f8RoseTree :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (b, List c)
freadSum_f8RoseTree = \(s : ss) p r ->
			mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_PpA4Listr p r))
constructorNamesAndArities_f8RoseTree :: RoseTree a -> [([Char], Int)]
constructorNamesAndArities_f8RoseTree = fconstructorNamesAndArities_f8RoseTree . out_f8RoseTree
inn_f8RoseTree :: (a, List (RoseTree a)) -> RoseTree a
inn_f8RoseTree = uncurry Fork2
freadSum_f5Maybe :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either () b)
freadSum_f5Maybe = \(s : ss) p r -> (freadSum_e (s : []) p r) <|> (freadSum_p ss p r)
constructorNamesAndArities_f5Maybe :: Maybe a -> [([Char], Int)]
constructorNamesAndArities_f5Maybe = fconstructorNamesAndArities_f5Maybe . out_f5Maybe
inn_f5Maybe :: Either () a -> Maybe a
inn_f5Maybe = either (const Nothing) Just
freadSum_e :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () ()
freadSum_e = \(s : ss) p r -> mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_e p r))
freadSum_Ppr :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (b, c)
freadSum_Ppr = \(s : ss) p r -> mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_Ppr p r))
fconstructorNamesAndArities_f0 :: Either () (a, b) -> [([Char], Int)]
fconstructorNamesAndArities_f0 x = map
				     (mapFst fconstructorName_f0)
				     (asTypeOf fconstructorsAndArities_f0 ((x, undefined) : []))
out_f0 :: [a] -> Either () (a, [a])
out_f0 x = case x of
	     [] -> Left ()
	     (a : b) -> Right (a, b)
freadSum_SrPrPpr ::
  ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (Either c (c, (b, c)))
freadSum_SrPrPpr = \(s : ss) p r -> (freadSum_r (s : []) p r) <|> (freadSum_PrPpr ss p r)
fconstructorNamesAndArities_f1A :: Either () (Either a (a, (b, a))) -> [([Char], Int)]
fconstructorNamesAndArities_f1A x = map
				      (mapFst fconstructorName_f1A)
				      (asTypeOf fconstructorsAndArities_f1A ((x, undefined) : []))
out_f1A :: A a -> Either () (Either (A a) (A a, (a, A a)))
out_f1A x = case x of
	      B -> Left ()
	      (C a) -> Right (Left a)
	      (D a b c) -> Right (Right (a, (b, c)))
uncurry3 :: (a -> b -> c -> d) -> (a, (b, c)) -> d
uncurry3 f p = uncurry (f (fst p)) (snd p)
freadSum_p :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () b
freadSum_p = \(s : ss) p r -> mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_p p r))
freadSum_Prr :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (c, c)
freadSum_Prr = \(s : ss) p r -> mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_Prr p r))
fconstructorNamesAndArities_f4Tree :: Either a (b, b) -> [([Char], Int)]
fconstructorNamesAndArities_f4Tree x = map
					 (mapFst fconstructorName_f4Tree)
					 (asTypeOf
					    fconstructorsAndArities_f4Tree
					    ((x, undefined) : []))
out_f4Tree :: Tree a -> Either a (Tree a, Tree a)
out_f4Tree x = case x of
		 (Leaf a) -> Left a
		 (Bin a b) -> Right (a, b)
prec :: ([Char], Int) -> Int
prec p = case (snd p) == 0 of
	   True -> high
	   _ -> high - 1
freadProd_PpA0r :: ArrowReadShow a => a () b -> a () c -> a () (b, [c])
freadProd_PpA0r = \p r -> (arr (\() -> ((), ()))) >>> ((freadProd_p p r) **> (freadProd_A0r p r))
fconstructorNamesAndArities_f4Rose :: (a, [b]) -> [([Char], Int)]
fconstructorNamesAndArities_f4Rose x = map
					 (mapFst fconstructorName_f4Rose)
					 (asTypeOf
					    fconstructorsAndArities_f4Rose
					    ((x, undefined) : []))
out_f4Rose :: Rose a -> (a, [Rose a])
out_f4Rose x = case x of
		 (Fork a b) -> (a, b)
fconstructorNamesAndArities_f4List :: Either () (a, b) -> [([Char], Int)]
fconstructorNamesAndArities_f4List x = map
					 (mapFst fconstructorName_f4List)
					 (asTypeOf
					    fconstructorsAndArities_f4List
					    ((x, undefined) : []))
out_f4List :: List a -> Either () (a, List a)
out_f4List x = case x of
		 Nil -> Left ()
		 (Cons a b) -> Right (a, b)
freadProd_A4TreeA4Listp :: ArrowReadShow a => a () b -> a () c -> a () (Tree (List b))
freadProd_A4TreeA4Listp = \p r -> (readSymbol " ") >>> (setPrec high (freadRest_A4TreeA4Listp p r))
fconstructorNamesAndArities_f10TreeOfList :: Tree (List a) -> [([Char], Int)]
fconstructorNamesAndArities_f10TreeOfList x = map
						(mapFst fconstructorName_f10TreeOfList)
						(asTypeOf
						   fconstructorsAndArities_f10TreeOfList
						   ((x, undefined) : []))
out_f10TreeOfList :: TreeOfList a -> Tree (List a)
out_f10TreeOfList x = case x of
			(TL a) -> a
freadProd_PpA4Listr :: ArrowReadShow a => a () b -> a () c -> a () (b, List c)
freadProd_PpA4Listr = \p r ->
			(arr (\() -> ((), ()))) >>> ((freadProd_p p r) **> (freadProd_A4Listr p r))
fconstructorNamesAndArities_f8RoseTree :: (a, List b) -> [([Char], Int)]
fconstructorNamesAndArities_f8RoseTree x = map
					     (mapFst fconstructorName_f8RoseTree)
					     (asTypeOf
						fconstructorsAndArities_f8RoseTree
						((x, undefined) : []))
out_f8RoseTree :: RoseTree a -> (a, List (RoseTree a))
out_f8RoseTree x = case x of
		     (Fork2 a b) -> (a, b)
fconstructorNamesAndArities_f5Maybe :: Either () a -> [([Char], Int)]
fconstructorNamesAndArities_f5Maybe x = map
					  (mapFst fconstructorName_f5Maybe)
					  (asTypeOf
					     fconstructorsAndArities_f5Maybe
					     ((x, undefined) : []))
out_f5Maybe :: Maybe a -> Either () a
out_f5Maybe x = case x of
		  Nothing -> Left ()
		  (Just a) -> Right a
freadProd_e :: ArrowReadShow a => a () b -> a () c -> a () ()
freadProd_e = \p r -> arr id
freadProd_Ppr :: ArrowReadShow a => a () b -> a () c -> a () (b, c)
freadProd_Ppr = \p r -> (arr (\() -> ((), ()))) >>> ((freadProd_p p r) **> (freadProd_r p r))
mapFst :: (a -> b) -> (a, c) -> (b, c)
mapFst f p = (f (fst p), snd p)
fconstructorName_f0 :: Either () (a, b) -> [Char]
fconstructorName_f0 = either (\_ -> "[]") (\_ -> ":")
fconstructorsAndArities_f0 :: [(Either () (a, b), Int)]
fconstructorsAndArities_f0 = (map (mapFst Left) fconstructorsAndArities_e) ++
			     (map (mapFst Right) fconstructorsAndArities_Ppr)
freadSum_r :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () c
freadSum_r = \(s : ss) p r -> mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_r p r))
freadSum_PrPpr :: ArrowReadShow a => [([Char], Int)] -> a () b -> a () c -> a () (c, (b, c))
freadSum_PrPpr = \(s : ss) p r ->
		   mayReadParen (prec s) ((readSymbol (fst s)) >>> (freadProd_PrPpr p r))
fconstructorName_f1A :: Either () (Either a (a, (b, a))) -> [Char]
fconstructorName_f1A = either (\_ -> "B") (either (\_ -> "C") (\_ -> "D"))
fconstructorsAndArities_f1A :: [(Either () (Either a (a, (b, a))), Int)]
fconstructorsAndArities_f1A = (map (mapFst Left) fconstructorsAndArities_e) ++
			      (map (mapFst Right) fconstructorsAndArities_SrPrPpr)
freadProd_p :: ArrowReadShow a => a () b -> a () c -> a () b
freadProd_p = \p r -> (readSymbol " ") >>> (setPrec high (freadRest_p p r))
freadProd_Prr :: ArrowReadShow a => a () b -> a () c -> a () (c, c)
freadProd_Prr = \p r -> (arr (\() -> ((), ()))) >>> ((freadProd_r p r) **> (freadProd_r p r))
fconstructorName_f4Tree :: Either a (b, b) -> [Char]
fconstructorName_f4Tree = either (\_ -> "Leaf") (\_ -> "Bin")
fconstructorsAndArities_f4Tree :: [(Either a (b, b), Int)]
fconstructorsAndArities_f4Tree = (map (mapFst Left) fconstructorsAndArities_p) ++
				 (map (mapFst Right) fconstructorsAndArities_Prr)
freadProd_A0r :: ArrowReadShow a => a () b -> a () c -> a () [c]
freadProd_A0r = \p r -> (readSymbol " ") >>> (setPrec high (freadRest_A0r p r))
fconstructorName_f4Rose :: (a, [b]) -> [Char]
fconstructorName_f4Rose = \_ -> "Fork"
fconstructorsAndArities_f4Rose :: [((a, [b]), Int)]
fconstructorsAndArities_f4Rose = (\x -> (x, fconstructorArity_PpA0r x) : []) undefined
fconstructorName_f4List :: Either () (a, b) -> [Char]
fconstructorName_f4List = either (\_ -> "Nil") (\_ -> "Cons")
fconstructorsAndArities_f4List :: [(Either () (a, b), Int)]
fconstructorsAndArities_f4List = (map (mapFst Left) fconstructorsAndArities_e) ++
				 (map (mapFst Right) fconstructorsAndArities_Ppr)
freadRest_A4TreeA4Listp :: ArrowReadShow a => a () b -> a () c -> a () (Tree (List b))
freadRest_A4TreeA4Listp = \p r -> pread_f4Tree (freadRest_A4Listp p r)
fconstructorName_f10TreeOfList :: Tree (List a) -> [Char]
fconstructorName_f10TreeOfList = \_ -> "TL"
fconstructorsAndArities_f10TreeOfList :: [(Tree (List a), Int)]
fconstructorsAndArities_f10TreeOfList = (\x -> (x, fconstructorArity_A4TreeA4Listp x) : [])
					  undefined
freadProd_A4Listr :: ArrowReadShow a => a () b -> a () c -> a () (List c)
freadProd_A4Listr = \p r -> (readSymbol " ") >>> (setPrec high (freadRest_A4Listr p r))
fconstructorName_f8RoseTree :: (a, List b) -> [Char]
fconstructorName_f8RoseTree = \_ -> "Fork2"
fconstructorsAndArities_f8RoseTree :: [((a, List b), Int)]
fconstructorsAndArities_f8RoseTree = (\x -> (x, fconstructorArity_PpA4Listr x) : []) undefined
fconstructorName_f5Maybe :: Either () a -> [Char]
fconstructorName_f5Maybe = either (\_ -> "Nothing") (\_ -> "Just")
fconstructorsAndArities_f5Maybe :: [(Either () a, Int)]
fconstructorsAndArities_f5Maybe = (map (mapFst Left) fconstructorsAndArities_e) ++
				  (map (mapFst Right) fconstructorsAndArities_p)
freadProd_r :: ArrowReadShow a => a () b -> a () c -> a () c
freadProd_r = \p r -> (readSymbol " ") >>> (setPrec high (freadRest_r p r))
fconstructorsAndArities_e :: [((), Int)]
fconstructorsAndArities_e = (\x -> (x, fconstructorArity_e x) : []) undefined
fconstructorsAndArities_Ppr :: [((a, b), Int)]
fconstructorsAndArities_Ppr = (\x -> (x, fconstructorArity_Ppr x) : []) undefined
freadProd_PrPpr :: ArrowReadShow a => a () b -> a () c -> a () (c, (b, c))
freadProd_PrPpr = \p r -> (arr (\() -> ((), ()))) >>> ((freadProd_r p r) **> (freadProd_Ppr p r))
fconstructorsAndArities_SrPrPpr :: [(Either a (a, (b, a)), Int)]
fconstructorsAndArities_SrPrPpr = (map (mapFst Left) fconstructorsAndArities_r) ++
				  (map (mapFst Right) fconstructorsAndArities_PrPpr)
freadRest_p :: ArrowReadShow a => a () b -> a () c -> a () b
freadRest_p = \p r -> p
fconstructorsAndArities_p :: [(a, Int)]
fconstructorsAndArities_p = (\x -> (x, fconstructorArity_p x) : []) undefined
fconstructorsAndArities_Prr :: [((a, a), Int)]
fconstructorsAndArities_Prr = (\x -> (x, fconstructorArity_Prr x) : []) undefined
freadRest_A0r :: ArrowReadShow a => a () b -> a () c -> a () [c]
freadRest_A0r = \p r -> pread_f0 (freadRest_r p r)
fconstructorArity_PpA0r :: (a, [b]) -> Int
fconstructorArity_PpA0r = \p -> (fconstructorArity_p (fst p)) + (fconstructorArity_A0r (snd p))
freadRest_A4Listp :: ArrowReadShow a => a () b -> a () c -> a () (List b)
freadRest_A4Listp = \p r -> pread_f4List (freadRest_p p r)
fconstructorArity_A4TreeA4Listp :: Tree (List a) -> Int
fconstructorArity_A4TreeA4Listp = const 1
freadRest_A4Listr :: ArrowReadShow a => a () b -> a () c -> a () (List c)
freadRest_A4Listr = \p r -> pread_f4List (freadRest_r p r)
fconstructorArity_PpA4Listr :: (a, List b) -> Int
fconstructorArity_PpA4Listr = \p ->
				(fconstructorArity_p (fst p)) + (fconstructorArity_A4Listr (snd p))
freadRest_r :: ArrowReadShow a => a () b -> a () c -> a () c
freadRest_r = \p r -> r
fconstructorArity_e :: () -> Int
fconstructorArity_e = const 0
fconstructorArity_Ppr :: (a, b) -> Int
fconstructorArity_Ppr = \p -> (fconstructorArity_p (fst p)) + (fconstructorArity_r (snd p))
fconstructorsAndArities_r :: [(a, Int)]
fconstructorsAndArities_r = (\x -> (x, fconstructorArity_r x) : []) undefined
fconstructorsAndArities_PrPpr :: [((a, (b, a)), Int)]
fconstructorsAndArities_PrPpr = (\x -> (x, fconstructorArity_PrPpr x) : []) undefined
fconstructorArity_p :: a -> Int
fconstructorArity_p = const 1
fconstructorArity_Prr :: (a, a) -> Int
fconstructorArity_Prr = \p -> (fconstructorArity_r (fst p)) + (fconstructorArity_r (snd p))
fconstructorArity_A0r :: [a] -> Int
fconstructorArity_A0r = const 1
fconstructorArity_A4Listr :: List a -> Int
fconstructorArity_A4Listr = const 1
fconstructorArity_r :: a -> Int
fconstructorArity_r = const 1
fconstructorArity_PrPpr :: (a, (b, a)) -> Int
fconstructorArity_PrPpr = \p -> (fconstructorArity_r (fst p)) + (fconstructorArity_Ppr (snd p))
